# Tests
# En dimension 2
terrain = [
    [100, 100, 100, 100, 100, 100, 100, 100, 100, 100],
    [100, 39, 17, 16, 30, 39, 56, 62, 51, 100],
    [100, 39, 18, 4, 10, 20, 43, 62, 53, 100],
    [100, 27, 22, 12, 18, 34, 43, 46, 42, 100],
    [100, 15, 23, 19, 30, 49, 45, 38, 30, 100],
    [100, 39, 43, 25, 27, 39, 36, 40, 40, 100],
    [100, 64, 59, 38, 36, 43, 39, 31, 31, 100],
    [100, 60, 49, 38, 42, 47, 55, 40, 22, 100],
    [100, 51, 38, 33, 45, 43, 49, 49, 28, 100],
    [100, 100, 100, 100, 100, 100, 100, 100, 100, 100]
]
assert rouler(terrain, 6, 1) == (4, 1)
assert rouler(terrain, 1, 1) == (2, 3)
assert rouler(terrain, 1, 7) == (2, 3)

# Tests supplémentaires
terrain = [[100, 100, 100, 100, 100, 100, 100, 100, 100,
            100, 100, 100, 100, 100, 100, 100, 100, 100],
           [100, 44, 49, 49, 51, 53, 58, 59, 49, 44, 42,
           33, 27, 24, 23, 35, 42, 100],
           [100, 41, 44, 41, 44, 54, 59, 56, 48, 46, 42,
           34, 29, 25, 25, 36, 41, 100],
           [100, 29, 29, 27, 30, 46, 61, 64, 59, 58, 52,
           41, 31, 24, 27, 37, 46, 100],
           [100, 16, 13, 13, 23, 41, 62, 69, 70, 74, 67,
           54, 44, 36, 40, 46, 49, 100],
           [100, 19, 11, 11, 25, 45, 65, 69, 67, 68, 67,
           62, 58, 55, 56, 55, 50, 100],
           [100, 24, 13, 12, 29, 47, 62, 68, 62, 58, 60,
           59, 62, 65, 62, 58, 55, 100],
           [100, 31, 19, 18, 31, 42, 51, 62, 62, 59, 63,
           61, 61, 62, 58, 60, 60, 100],
           [100, 42, 29, 28, 35, 41, 48, 55, 55, 55, 57,
           59, 60, 55, 50, 58, 58, 100],
           [100, 44, 30, 26, 33, 37, 47, 49, 43, 44, 44,
           49, 59, 55, 47, 52, 51, 100],
           [100, 48, 36, 28, 30, 33, 40, 39, 31, 33, 34,
           40, 55, 58, 52, 49, 43, 100],
           [100, 59, 54, 45, 40, 41, 43, 35, 25, 25, 34,
           43, 55, 56, 52, 42, 30, 100],
           [100, 66, 66, 59, 49, 49, 49, 41, 31, 28, 35,
           44, 50, 51, 49, 39, 29, 100],
           [100, 63, 61, 54, 44, 47, 47, 42, 41, 38, 39,
           45, 44, 45, 47, 38, 33, 100],
           [100, 54, 52, 42, 37, 44, 51, 48, 47, 48, 49,
           50, 43, 42, 46, 39, 37, 100],
           [100, 46, 47, 39, 34, 43, 56, 56, 49, 48, 44,
           39, 39, 46, 55, 53, 47, 100],
           [100, 45, 46, 40, 36, 41, 55, 62, 51, 43, 34,
           31, 38, 46, 60, 65, 55, 100],
           [100, 100, 100, 100, 100, 100, 100, 100, 100,
           100, 100, 100, 100, 100, 100, 100, 100, 100]]
solutions = {(1, 1): (5, 2), (1, 2): (5, 2), (1, 3): (5, 2), (1, 4): (5, 2),
             (1, 5): (5, 2), (1, 6): (5, 2), (1, 7): (1, 14), (1, 8): (1, 14),
             (1, 9): (1, 14), (1, 10): (1, 14), (1, 11): (1, 14),
             (1, 12): (1, 14), (1, 13): (1, 14), (1, 14): (1, 14),
             (1, 15): (1, 14), (1, 16): (1, 14), (2, 1): (5, 2),
             (2, 2): (5, 2), (2, 3): (5, 2), (2, 4): (5, 2), (2, 5): (5, 2), (2, 6): (5, 3), (2, 7): (1, 14), (2, 8): (1, 14),
             (2, 9): (1, 14), (2, 10): (1, 14), (2, 11): (1, 14),
             (2, 12): (1, 14), (2, 13): (1, 14), (2, 14): (1, 14),
             (2, 15): (1, 14), (2, 16): (1, 14), (3, 1): (5, 2), (3, 2): (5, 2), (3, 3): (5, 2),
             (3, 4): (5, 2), (3, 5): (5, 3), (3, 6): (5, 3), (3, 7): (1, 14), (3, 8): (1, 14),
             (3, 9): (1, 14), (3, 10): (1, 14), (3, 11): (1, 14),
             (3, 12): (3, 13), (3, 13): (3, 13), (3, 14): (3, 13),
             (3, 15): (1, 14), (3, 16): (1, 14), (4, 1): (5, 2), (4, 2): (5, 2), (4, 3): (5, 2),
             (4, 4): (5, 3), (4, 5): (5, 3), (4, 6): (5, 3), (4, 7): (1, 14), (4, 8): (1, 14),
             (4, 9): (1, 14), (4, 10): (1, 14), (4, 11): (3, 13),
             (4, 12): (3, 13), (4, 13): (3, 13), (4, 14): (3, 13),
             (4, 15): (3, 13), (4, 16): (1, 14), (5, 1): (5, 2), (5, 2): (5, 2), (5, 3): (5, 3),
             (5, 4): (5, 3), (5, 5): (5, 3), (5, 6): (5, 3), (5, 7): (5, 3), (5, 8): (6, 9),
             (5, 9): (6, 9), (5, 10): (3, 13), (5, 11): (3, 13),
             (5, 12): (3, 13), (5, 13): (3, 13), (5, 14): (3, 13),
             (5, 15): (3, 13), (5, 16): (3, 13), (6, 1): (5, 2), (6, 2): (5, 2), (6, 3): (5, 2),
             (6, 4): (5, 3), (6, 5): (5, 3), (6, 6): (5, 3), (6, 7): (5, 2), (6, 8): (6, 9),
             (6, 9): (6, 9), (6, 10): (6, 9), (6, 11): (3, 13),
             (6, 12): (3, 13), (6, 13): (3, 13), (6, 14): (3, 13),
             (6, 15): (3, 13), (6, 16): (3, 13), (7, 1): (5, 2), (7, 2): (5, 2), (7, 3): (5, 2),
             (7, 4): (5, 2), (7, 5): (5, 3), (7, 6): (5, 2), (7, 7): (9, 3), (7, 8): (11, 8),
             (7, 9): (11, 8), (7, 10): (11, 8), (7, 11): (11, 8),
             (7, 12): (9, 14), (7, 13): (9, 14), (7, 14): (9, 14),
             (7, 15): (9, 14), (7, 16): (3, 13), (8, 1): (5, 2), (8, 2): (5, 2), (8, 3): (5, 2), (8, 4):
             (5, 2), (8, 5): (5, 2), (8, 6): (9, 3), (8, 7): (11, 8), (8, 8): (11, 8),
             (8, 9): (11, 8), (8, 10): (11, 8), (8, 11): (11, 8),
             (8, 12): (11, 9), (8, 13): (9, 14), (8, 14): (9, 14), (8, 15): (9, 14),
             (8, 16): (12, 16), (9, 1): (5, 2), (9, 2): (9, 3), (9, 3): (9, 3), (9, 4): (9, 3),
             (9, 5): (9, 3), (9, 6): (9, 3), (9, 7): (11, 8), (9, 8): (11, 8), (9, 9): (11, 8),
             (9, 10): (11, 8), (9, 11): (11, 9), (9, 12): (11, 9),
             (9, 13): (9, 14), (9, 14): (9, 14), (9, 15): (12, 16),
             (9, 16): (12, 16), (10, 1): (9, 3), (10, 2): (9, 3), (10, 3): (9, 3),
             (10, 4): (9, 3), (10, 5): (9, 3), (10, 6): (9, 3), (10, 7): (11, 8),
             (10, 8): (11, 8), (10, 9): (11, 8), (10, 10): (11, 9), (10, 11): (11, 9),
             (10, 12): (11, 9), (10, 13): (9, 14), (10, 14): (12, 16), (10, 15): (12, 16),
             (10, 16): (12, 16), (11, 1): (9, 3), (11, 2): (9, 3), (11, 3): (9, 3),
             (11, 4): (9, 3), (11, 5): (9, 3), (11, 6): (9, 3), (11, 7): (11, 8),
             (11, 8): (11, 8), (11, 9): (11, 9), (11, 10): (11, 9), (11, 11): (11, 9),
             (11, 12): (11, 9), (11, 13): (12, 16), (11, 14): (12, 16), (11, 15): (12, 16),
             (11, 16): (12, 16), (12, 1): (9, 3), (12, 2): (9, 3), (12, 3): (9, 3),
             (12, 4): (9, 3), (12, 5): (9, 3), (12, 6): (11, 8), (12, 7): (11, 8),
             (12, 8): (11, 8), (12, 9): (11, 8), (12, 10): (11, 9), (12, 11): (11, 9),
             (12, 12): (11, 9), (12, 13): (16, 11), (12, 14): (12, 16), (12, 15): (12, 16),
             (12, 16): (12, 16), (13, 1): (15, 4), (13, 2): (15, 4), (13, 3): (15, 4),
             (13, 4): (15, 4), (13, 5): (15, 4), (13, 6): (11, 8), (13, 7): (11, 8),
             (13, 8): (11, 8), (13, 9): (11, 8), (13, 10): (11, 8), (13, 11): (11, 9),
             (13, 12): (16, 11), (13, 13): (16, 11), (13, 14): (12, 16), (13, 15): (12, 16),
             (13, 16): (12, 16), (14, 1): (16, 1), (14, 2): (15, 4), (14, 3): (15, 4),
             (14, 4): (15, 4), (14, 5): (15, 4), (14, 6): (11, 8), (14, 7): (11, 8),
             (14, 8): (11, 8), (14, 9): (11, 8), (14, 10): (11, 8), (14, 11): (11, 8),
             (14, 12): (16, 11), (14, 13): (16, 11), (14, 14): (12, 16), (14, 15): (12, 16),
             (14, 16): (12, 16), (15, 1): (16, 1), (15, 2): (15, 4), (15, 3): (15, 4),
             (15, 4): (15, 4), (15, 5): (15, 4), (15, 6): (15, 4), (15, 7): (11, 8),
             (15, 8): (16, 11), (15, 9): (16, 11), (15, 10): (16, 11), (15, 11): (16, 11),
             (15, 12): (16, 11), (15, 13): (16, 11), (15, 14): (12, 16), (15, 15): (12, 16),
             (15, 16): (12, 16), (16, 1): (16, 1), (16, 2): (15, 4), (16, 3): (15, 4),
             (16, 4): (15, 4), (16, 5): (15, 4), (16, 6): (15, 4), (16, 7): (16, 11),
             (16, 8): (16, 11), (16, 9): (16, 11), (16, 10): (16, 11), (16, 11): (16, 11),
             (16, 12): (16, 11), (16, 13): (16, 11), (16, 14): (16, 11), (16, 15): (12, 16),
             (16, 16): (12, 16)}
for depart, arrivee in solutions.items():
    assert rouler(terrain, *depart) == arrivee
